from collections import deque

# Чтение входных данных
n, m, k = map(int, input().split())
graph = [[] for _ in range(n + 1)]

# Построение графа
for _ in range(m):
    a, b = map(int, input().split())
    graph[a].append(b)
    graph[b].append(a)

guards = {}
for _ in range(k):
    p, h = map(int, input().split())
    guards[p] = h


def find_guarded_warehouses():
    guarded = set()

    for p, h in guards.items():
        visited = [False] * (n + 1)
        queue = deque([(p, 0)])
        visited[p] = True

        while queue:
            curr, dist = queue.popleft()
            if dist <= h:
                guarded.add(curr)
                for neighbor in graph[curr]:
                    if not visited[neighbor]:
                        visited[neighbor] = True
                        queue.append((neighbor, dist + 1))

    return sorted(guarded)


result = find_guarded_warehouses()
print(len(result))
if result:
    print(" ".join(map(str, result)))
